var redis = require('./redis');

var toolkits = new Array();

function RedisToolkit(){


}

RedisToolkit.prototype.getAll = function () {

};

module.exports = RedisToolkit;

module.exports.getAll = function * getAll() {
  // on récupère un set d'identifiants pour itération et récupération des toolkits
  // set d'identifiants => [ 'toolkit:1', 'toolkit:2', ..., 'toolkit:N']
  for (id in  yield redis.smembers('toolkits')) {
    var item = yield redis.hmget('toolkit:'+id, ['path', 'name'] );
    toolkits.push({path: item[0], name: item[1]});
  }

  return toolkits;
}

module.exports.add = function * add(name, path){
  var next_toolkit_id = null;
  // retrieve last id commited
  var exists_next_toolkit_id = yield redis.exists('next_toolkit_id');

  // if there are some toolkits in db
  if(exists_next_toolkit_id){
    next_toolkit_id = yield redis.incr('next_toolkit_id');
  }else{
    // we create index for toolkit:ID management
    next_toolkit_id = 1;
    yield redis.set('next_toolkit_id', next_toolkit_id);
  }
  // we increment the current toolkit ID
  next_toolkit_id = 'toolkit:' + next_toolkit_id;
  redis.sadd('toolkits', next_toolkit_id );
  redis.hmset(next_toolkit_id, ['name', name, 'path', path ]);

  return {name: name, path: path};
}

module.exports.del = function * del(id){
  return yield redis.del('toolkits', 'toolkit:' + id);
}
